Index: /LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90	(revision 2408)
@@ -23,6 +23,6 @@
       USE dimphy
       USE ioipsl
-      USE comgeomphy , ONLY:rlond,rlatd
       USE indice_sol_mod
+      USE print_control_mod, ONLY: lunout,prt_level
       IMPLICIT NONE
 
@@ -62,9 +62,7 @@
 !   -------------
 
-#include "dimensions.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
 #include "FCTTRE.h"
-#include "iniprint.h"
 #include "thermcell.h"
 
@@ -565,5 +563,5 @@
       if (.not. (f0(1).ge.0.) ) then
               abort_message = '.not. (f0(1).ge.0.)'
-              CALL abort_gcm (modname,abort_message,1)
+              CALL abort_physic (modname,abort_message,1)
       endif
 
@@ -695,5 +693,5 @@
       if (ierr==1) then
            abort_message = 'thermcellV0_main: les thermiques vont trop haut '
-           CALL abort_gcm (modname,abort_message,1)
+           CALL abort_physic (modname,abort_message,1)
       endif
 
@@ -749,302 +747,23 @@
       enddo
 !
-
+! $Id$
+!
+      CALL thermcell_alp(ngrid,nlay,ptimestep  &
+     &                  ,pplay,pplev  &
+     &                  ,fm0,entr0,lmax  &
+     &                  ,Ale_bl,Alp_bl,lalim_conv,wght_th &
+     &                  ,zw2,fraca &
+!!! necessire en plus
+     &                  ,pcon,rhobarz,wth3,wmax_sec,lalim,fm,alim_star,zmax &
 !!! nrlmd le 10/04/2012
-
-!------------Test sur le LCL des thermiques
-    do ig=1,ngrid
-      ok_lcl(ig)=.false.
-      if ( (pcon(ig) .gt. pplay(ig,klev-1)) .and. (pcon(ig) .lt. pplay(ig,1)) ) ok_lcl(ig)=.true.
-    enddo
-
-!------------Localisation des niveaux entourant le LCL et du coef d'interpolation
-    do l=1,nlay-1
-      do ig=1,ngrid
-        if (ok_lcl(ig)) then 
-!ATTENTION,zw2 calcule en pplev
-!          if ((pplay(ig,l) .ge. pcon(ig)) .and. (pplay(ig,l+1) .le. pcon(ig))) then
-!          klcl(ig)=l
-!          interp(ig)=(pcon(ig)-pplay(ig,klcl(ig)))/(pplay(ig,klcl(ig)+1)-pplay(ig,klcl(ig)))
-!          endif
-          if ((pplev(ig,l) .ge. pcon(ig)) .and. (pplev(ig,l+1) .le. pcon(ig))) then
-          klcl(ig)=l
-          interp(ig)=(pcon(ig)-pplev(ig,klcl(ig)))/(pplev(ig,klcl(ig)+1)-pplev(ig,klcl(ig)))
-          endif
-        endif
-      enddo
-    enddo
-
-!------------Hauteur des thermiques
-!!jyg le 27/04/2012
-!!    do ig =1,ngrid
-!!    rhobarz0(ig)=rhobarz(ig,klcl(ig))+(rhobarz(ig,klcl(ig)+1) &
-!! &               -rhobarz(ig,klcl(ig)))*interp(ig)
-!!    zlcl(ig)=(pplev(ig,1)-pcon(ig))/(rhobarz0(ig)*RG)
-!!    zmax(ig)=pphi(ig,lmax(ig))/rg
-!!      if ( (.not.ok_lcl(ig)) .or. (zlcl(ig).gt.zmax(ig)) ) zlcl(ig)=zmax(ig) ! Si zclc > zmax alors on pose zlcl = zmax
-!!    enddo
-    do ig =1,ngrid
-!CR:REHABILITATION ZMAX CONTINU
-!     zmax(ig)=pphi(ig,lmax(ig))/rg
-     if (ok_lcl(ig)) then 
-      rhobarz0(ig)=rhobarz(ig,klcl(ig))+(rhobarz(ig,klcl(ig)+1) &
- &               -rhobarz(ig,klcl(ig)))*interp(ig)
-      zlcl(ig)=(pplev(ig,1)-pcon(ig))/(rhobarz0(ig)*RG)
-      zlcl(ig)=min(zlcl(ig),zmax(ig))   ! Si zlcl > zmax alors on pose zlcl = zmax
-     else
-      rhobarz0(ig)=0.
-      zlcl(ig)=zmax(ig)
-     endif
-    enddo
-!!jyg fin
-
-!------------Calcul des propriétés du thermique au LCL 
-  IF ( (iflag_trig_bl.ge.1) .or. (iflag_clos_bl.ge.1) ) THEN 
-
-  !-----Initialisation de la TKE moyenne 
-   do l=1,nlay
-    do ig=1,ngrid
-     pbl_tke_max(ig,l)=0.
-    enddo
-   enddo
-
-!-----Calcul de la TKE moyenne 
-   do nsrf=1,nbsrf
-    do l=1,nlay
-     do ig=1,ngrid
-     pbl_tke_max(ig,l)=pctsrf(ig,nsrf)*pbl_tke(ig,l,nsrf)+pbl_tke_max(ig,l)
-     enddo
-    enddo
-   enddo
-
-!-----Initialisations des TKE dans et hors des thermiques 
-   do l=1,nlay
-    do ig=1,ngrid
-    therm_tke_max(ig,l)=pbl_tke_max(ig,l)
-    env_tke_max(ig,l)=pbl_tke_max(ig,l)
-    enddo
-   enddo
-
-!-----Calcul de la TKE transportée par les thermiques : therm_tke_max
-   call thermcell_tke_transport(ngrid,nlay,ptimestep,fm0,entr0,  &
-  &           rg,pplev,therm_tke_max)
-!   print *,' thermcell_tke_transport -> '   !!jyg
-
-!-----Calcul des profils verticaux de TKE hors thermiques : env_tke_max, et de la vitesse verticale grande échelle : W_ls
-   do l=1,nlay
-    do ig=1,ngrid
-     pbl_tke_max(ig,l)=fraca(ig,l)*therm_tke_max(ig,l)+(1.-fraca(ig,l))*env_tke_max(ig,l)         !  Recalcul de TKE moyenne aprés transport de TKE_TH
-     env_tke_max(ig,l)=(pbl_tke_max(ig,l)-fraca(ig,l)*therm_tke_max(ig,l))/(1.-fraca(ig,l))       !  Recalcul de TKE dans  l'environnement aprés transport de TKE_TH
-     w_ls(ig,l)=-1.*omega(ig,l)/(RG*rhobarz(ig,l))                                                !  Vitesse verticale de grande échelle
-    enddo
-   enddo
-!    print *,' apres w_ls = '   !!jyg
-
-  do ig=1,ngrid
-   if (ok_lcl(ig)) then
-     fraca0(ig)=fraca(ig,klcl(ig))+(fraca(ig,klcl(ig)+1) &
- &             -fraca(ig,klcl(ig)))*interp(ig)
-     w0(ig)=zw2(ig,klcl(ig))+(zw2(ig,klcl(ig)+1) &
- &         -zw2(ig,klcl(ig)))*interp(ig)
-     w_conv(ig)=w_ls(ig,klcl(ig))+(w_ls(ig,klcl(ig)+1) &
- &             -w_ls(ig,klcl(ig)))*interp(ig)
-     therm_tke_max0(ig)=therm_tke_max(ig,klcl(ig)) &
- &                     +(therm_tke_max(ig,klcl(ig)+1)-therm_tke_max(ig,klcl(ig)))*interp(ig)
-     env_tke_max0(ig)=env_tke_max(ig,klcl(ig))+(env_tke_max(ig,klcl(ig)+1) &
- &                   -env_tke_max(ig,klcl(ig)))*interp(ig)
-     pbl_tke_max0(ig)=pbl_tke_max(ig,klcl(ig))+(pbl_tke_max(ig,klcl(ig)+1) &
- &                   -pbl_tke_max(ig,klcl(ig)))*interp(ig)
-     if (therm_tke_max0(ig).ge.20.) therm_tke_max0(ig)=20.
-     if (env_tke_max0(ig).ge.20.) env_tke_max0(ig)=20.
-     if (pbl_tke_max0(ig).ge.20.) pbl_tke_max0(ig)=20.
-   else 
-     fraca0(ig)=0.
-     w0(ig)=0.
-!!jyg le 27/04/2012
-!!     zlcl(ig)=0.
-!!
-   endif
-  enddo
-
-  ENDIF ! IF ( (iflag_trig_bl.ge.1) .or. (iflag_clos_bl.ge.1) )
-!  print *,'ENDIF  ( (iflag_trig_bl.ge.1) .or. (iflag_clos_bl.ge.1) ) '    !!jyg
-
-!------------Triggering------------------
-  IF (iflag_trig_bl.ge.1) THEN 
-
-!-----Initialisations
-   depth(:)=0.
-   n2(:)=0.
-   s2(:)=100. ! some low value, arbitrary
-   s_max(:)=0.
-
-!-----Epaisseur du nuage (depth) et détermination de la queue du spectre de panaches (n2,s2) et du panache le plus gros (s_max)
-   do ig=1,ngrid
-     zmax_moy(ig)=zlcl(ig)+zmax_moy_coef*(zmax(ig)-zlcl(ig))
-     depth(ig)=zmax_moy(ig)-zlcl(ig)
-     hmin(ig)=hmincoef*zlcl(ig)
-     if (depth(ig).ge.10.) then 
-       s2(ig)=(hcoef*depth(ig)+hmin(ig))**2
-       n2(ig)=(1.-eps1)*fraca0(ig)*airephy(ig)/s2(ig)
-!!
-!!jyg le 27/04/2012
-!!       s_max(ig)=s2(ig)*log(n2(ig))
-!!       if (n2(ig) .lt. 1) s_max(ig)=0.
-       s_max(ig)=s2(ig)*log(max(n2(ig),1.))
-!!fin jyg
-     else
-       n2(ig)=0.
-       s_max(ig)=0.
-     endif
-   enddo
-!   print *,'avant Calcul de Wmax '    !!jyg
-
-!-----Calcul de Wmax et ALE_BL_STAT associée
-!!jyg le 30/04/2012
-!!   do ig=1,ngrid
-!!     if ( (depth(ig).ge.10.) .and. (s_max(ig).gt.1.) ) then
-!!     w_max(ig)=w0(ig)*(1.+sqrt(2.*log(s_max(ig)/su)-log(2.*3.14)-log(2.*log(s_max(ig)/su)-log(2.*3.14))))
-!!     ale_bl_stat(ig)=0.5*w_max(ig)**2
-!!     else
-!!     w_max(ig)=0.
-!!     ale_bl_stat(ig)=0.
-!!     endif
-!!   enddo
-   susqr2pi=su*sqrt(2.*Rpi)
-   Reuler=exp(1.)
-   do ig=1,ngrid
-     if ( (depth(ig).ge.10.) .and. (s_max(ig).gt.susqr2pi*Reuler) ) then
-      w_max(ig)=w0(ig)*(1.+sqrt(2.*log(s_max(ig)/susqr2pi)-log(2.*log(s_max(ig)/susqr2pi))))
-      ale_bl_stat(ig)=0.5*w_max(ig)**2
-     else
-      w_max(ig)=0.
-      ale_bl_stat(ig)=0.
-     endif
-   enddo
-
-  ENDIF ! iflag_trig_bl
-!  print *,'ENDIF  iflag_trig_bl'    !!jyg
-
-!------------Closure------------------
-
-  IF (iflag_clos_bl.ge.2) THEN 
-
-!-----Calcul de ALP_BL_STAT
-  do ig=1,ngrid
-  alp_bl_det(ig)=0.5*coef_m*rhobarz0(ig)*(w0(ig)**3)*fraca0(ig)*(1.-2.*fraca0(ig))/((1.-fraca0(ig))**2)
-  alp_bl_fluct_m(ig)=1.5*rhobarz0(ig)*fraca0(ig)*(w_conv(ig)+coef_m*w0(ig))* &
- &                   (w0(ig)**2)
-  alp_bl_fluct_tke(ig)=3.*coef_m*rhobarz0(ig)*w0(ig)*fraca0(ig)*(therm_tke_max0(ig)-env_tke_max0(ig)) &
- &                    +3.*rhobarz0(ig)*w_conv(ig)*pbl_tke_max0(ig)
-    if (iflag_clos_bl.ge.2) then 
-    alp_bl_conv(ig)=1.5*coef_m*rhobarz0(ig)*fraca0(ig)*(fraca0(ig)/(1.-fraca0(ig)))*w_conv(ig)* &
- &                   (w0(ig)**2)
-    else
-    alp_bl_conv(ig)=0.
-    endif
-  alp_bl_stat(ig)=alp_bl_det(ig)+alp_bl_fluct_m(ig)+alp_bl_fluct_tke(ig)+alp_bl_conv(ig)
-  enddo
-
-!-----Sécurité ALP infinie
-  do ig=1,ngrid
-   if (fraca0(ig).gt.0.98) alp_bl_stat(ig)=2.
-  enddo
-
-  ENDIF ! (iflag_clos_bl.ge.2)
-
+     &                  ,pbl_tke,pctsrf,omega,airephy &
+     &                  ,zlcl,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &
+     &                  ,n2,s2,ale_bl_stat &
+     &                  ,therm_tke_max,env_tke_max &
+     &                  ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke &
+     &                  ,alp_bl_conv,alp_bl_stat &
 !!! fin nrlmd le 10/04/2012
-
-      if (prt_level.ge.10) then
-         ig=igout
-         do l=1,nlay
-            print*,'14f OK convect8 ig,l,zha zh zpspsk ',ig,l,zha(ig,l),zh(ig,l),zpspsk(ig,l)
-            print*,'14g OK convect8 ig,l,po',ig,l,po(ig,l)
-         enddo
-      endif
-
-!      print*,'avant calcul ale et alp' 
-!calcul de ALE et ALP pour la convection
-      Alp_bl(:)=0.
-      Ale_bl(:)=0.
-!          print*,'ALE,ALP ,l,zw2(ig,l),Ale_bl(ig),Alp_bl(ig)'
-      do l=1,nlay
-      do ig=1,ngrid
-           Alp_bl(ig)=max(Alp_bl(ig),0.5*rhobarz(ig,l)*wth3(ig,l) )
-           Ale_bl(ig)=max(Ale_bl(ig),0.5*zw2(ig,l)**2)
-!          print*,'ALE,ALP',l,zw2(ig,l),Ale_bl(ig),Alp_bl(ig)
-      enddo
-      enddo
-
-! Ale sec (max de wmax/2 sous la zone d'inhibition) dans
-! le cas iflag_trig_bl=3
-      IF (iflag_trig_bl==3) Ale_bl(:)=0.5*wmax_sec(:)**2
-
-!test:calcul de la ponderation des couches pour KE
-!initialisations
-
-      fm_tot(:)=0.
-      wght_th(:,:)=1.
-      lalim_conv(:)=lalim(:)
-
-      do k=1,klev
-         do ig=1,ngrid
-            if (k<=lalim_conv(ig)) fm_tot(ig)=fm_tot(ig)+fm(ig,k)
-         enddo
-      enddo
-
-! assez bizarre car, si on est dans la couche d'alim et que alim_star et
-! plus petit que 1.e-10, on prend wght_th=1.
-      do k=1,klev
-         do ig=1,ngrid
-            if (k<=lalim_conv(ig).and.alim_star(ig,k)>1.e-10) then
-               wght_th(ig,k)=alim_star(ig,k)
-            endif
-         enddo
-      enddo
-
-!      print*,'apres wght_th'
-!test pour prolonger la convection
-      do ig=1,ngrid
-!v1d  if ((alim_star(ig,1).lt.1.e-10).and.(therm)) then
-      if ((alim_star(ig,1).lt.1.e-10)) then
-      lalim_conv(ig)=1
-      wght_th(ig,1)=1.
-!      print*,'lalim_conv ok',lalim_conv(ig),wght_th(ig,1)
-      endif
-      enddo
-
-!------------------------------------------------------------------------
-! Modif CR/FH 20110310 : Alp integree sur la verticale.
-! Integrale verticale de ALP.
-! wth3 etant aux niveaux inter-couches, on utilise d play comme masse des
-! couches
-!------------------------------------------------------------------------
-
-      alp_int(:)=0.
-      dp_int(:)=0.
-      do l=2,nlay
-        do ig=1,ngrid
-           if(l.LE.lmax(ig)) THEN
-           zdp=pplay(ig,l-1)-pplay(ig,l)
-           alp_int(ig)=alp_int(ig)+0.5*rhobarz(ig,l)*wth3(ig,l)*zdp
-           dp_int(ig)=dp_int(ig)+zdp
-           endif
-        enddo
-      enddo
-
-      if (iflag_coupl>=3 .and. iflag_coupl<=5) then
-      do ig=1,ngrid
-!valeur integree de alp_bl * 0.5:
-        if (dp_int(ig)>0.) then
-        Alp_bl(ig)=alp_int(ig)/dp_int(ig)
-        endif
-      enddo!
-      endif
-
-
-! Facteur multiplicatif sur Alp_bl
-      Alp_bl(:)=alp_bl_k*Alp_bl(:)
-
-!------------------------------------------------------------------------
+     &                   )
+
 
 
@@ -1097,6 +816,6 @@
 
       subroutine test_ltherm(klon,klev,pplev,pplay,long,seuil,ztv,po,ztva,zqla,f_star,zw2,comment)
+      USE print_control_mod, ONLY: prt_level
       IMPLICIT NONE
-#include "iniprint.h"
 
       integer i, k, klon,klev
@@ -1138,7 +857,7 @@
       subroutine thermcell_tke_transport(ngrid,nlay,ptimestep,fm0,entr0,  &
      &           rg,pplev,therm_tke_max)
+      USE print_control_mod, ONLY: prt_level
       implicit none
 
-#include "iniprint.h"
 !=======================================================================
 !
Index: /LMDZ5/branches/testing/libf/phylmd/thermcell_old.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/thermcell_old.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/thermcell_old.F90	(revision 2408)
@@ -31,5 +31,4 @@
   ! -------------
 
-  include "dimensions.h"
   include "YOMCST.h"
 
@@ -520,5 +519,5 @@
       IF (fracd(ig,l)<0.1) THEN
         abort_message = 'fracd trop petit'
-        CALL abort_gcm(modname, abort_message, 1)
+        CALL abort_physic(modname, abort_message, 1)
       ELSE
         ! vitesse descendante "diagnostique"
@@ -742,6 +741,4 @@
   ! -------------
 
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
   include "YOMCST.h"
   include "YOETHF.h"
@@ -1747,5 +1744,5 @@
         PRINT *, 'THERMCELL PB ig=', ig, '   l=', l
         abort_message = 'THERMCELL PB'
-        CALL abort_gcm(modname, abort_message, 1)
+        CALL abort_physic(modname, abort_message, 1)
       END IF
       ! if ((zw2(ig,l+1).gt.1.e-10).and.(zw2(ig,l).gt.1.e-10).and.
@@ -2051,5 +2048,5 @@
       IF (fracd(ig,l)<0.1 .AND. (test(ig)==1)) THEN
         abort_message = 'fracd trop petit'
-        CALL abort_gcm(modname, abort_message, 1)
+        CALL abort_physic(modname, abort_message, 1)
       ELSE
         ! vitesse descendante "diagnostique"
@@ -2345,6 +2342,4 @@
   ! -------------
 
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
   include "YOMCST.h"
   include "YOETHF.h"
@@ -3101,5 +3096,5 @@
       IF (fracd(ig,l)<0.1) THEN
         abort_message = 'fracd trop petit'
-        CALL abort_gcm(modname, abort_message, 1)
+        CALL abort_physic(modname, abort_message, 1)
       ELSE
         ! vitesse descendante "diagnostique"
@@ -3278,6 +3273,4 @@
   ! -------------
 
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
   include "YOMCST.h"
 
@@ -3906,5 +3899,5 @@
       IF (fracd(ig,l)<0.1) THEN
         abort_message = 'fracd trop petit'
-        CALL abort_gcm(modname, abort_message, 1)
+        CALL abort_physic(modname, abort_message, 1)
       ELSE
         ! vitesse descendante "diagnostique"
@@ -4139,7 +4132,4 @@
   ! =======================================================================
 
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
-
   INTEGER ngrid, nlay
 
@@ -4235,7 +4225,4 @@
 
   ! =======================================================================
-
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
 
   INTEGER ngrid, nlay
@@ -4342,7 +4329,4 @@
   ! =======================================================================
 
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
-
   INTEGER ngrid, nlay
 
@@ -4419,7 +4403,4 @@
 
   ! =======================================================================
-
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
 
   INTEGER ngrid, nlay
@@ -4561,6 +4542,4 @@
   ! -------------
 
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
   include "YOMCST.h"
 
@@ -5209,5 +5188,5 @@
       IF (fracd(ig,l)<0.1) THEN
         abort_message = 'fracd trop petit'
-        CALL abort_gcm(modname, abort_message, 1)
+        CALL abort_physic(modname, abort_message, 1)
       ELSE
         ! vitesse descendante "diagnostique"
Index: /LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90	(revision 2408)
@@ -13,4 +13,5 @@
 USE IOIPSL, ONLY : getin
 
+       USE print_control_mod, ONLY: prt_level
        IMPLICIT NONE
 
@@ -18,5 +19,4 @@
 #include "YOETHF.h"
 #include "FCTTRE.h"
-#include "iniprint.h"
 #include "thermcell.h"
 
@@ -82,4 +82,5 @@
       real zbuoyjam(ngrid,klev),zdqtjam(ngrid,klev)
       real zbuoybis,zdz2,zdz3,lmel,entrbis,zdzbis
+      real d_temp(ngrid)
       real ztv1,ztv2,factinv,zinv,zlmel
       real zlmelup,zlmeldwn,zlt,zltdwn,zltup
@@ -104,4 +105,5 @@
       REAL,SAVE :: detr_q_power,detr_q_power_omp=0.5
       REAL,SAVE :: mix0,mix0_omp=0.
+      INTEGER,SAVE :: thermals_flag_alim,thermals_flag_alim_omp=0
 
       LOGICAL, SAVE :: first=.true.
@@ -127,4 +129,5 @@
      CALL getin('thermals_detr_q_power',detr_q_power_omp)
      CALL getin('thermals_mix0',mix0_omp)
+     CALL getin('thermals_flag_alim',thermals_flag_alim_omp)
 !    CALL getin('thermals_X',X_omp)
 !    X=X_omp
@@ -140,4 +143,5 @@
      detr_q_power=detr_q_power_omp
      mix0=mix0_omp
+     thermals_flag_alim=thermals_flag_alim_omp
       first=.false.
       ENDIF
@@ -188,5 +192,4 @@
       lmix_bis(:)=2
       wmaxa(:)=0.
-      lalim(:)=1
 
 
@@ -195,31 +198,10 @@
 ! couches sont instables.
 !-------------------------------------------------------------------------
+
       active(:)=ztv(:,1)>ztv(:,2)
-
-!-------------------------------------------------------------------------
-! Definition de l'alimentation a l'origine dans thermcell_init
-!-------------------------------------------------------------------------
-      do l=1,klev-1
-         do ig=1,ngrid
-            if (ztv(ig,l)> ztv(ig,l+1) .and. ztv(ig,1)>=ztv(ig,l) ) then
-               alim_star(ig,l)=MAX((ztv(ig,l)-ztv(ig,l+1)),0.)  &
-     &                       *sqrt(zlev(ig,l+1)) 
-               lalim(ig)=l+1
-               alim_star_tot(ig)=alim_star_tot(ig)+alim_star(ig,l)
-!               print*,'alim2',l,ztv(ig,l),ztv(ig,l+1),alim_star(ig,l)
-            endif
-         enddo
-      enddo
-      do l=1,klev
-         do ig=1,ngrid 
-            if (alim_star_tot(ig) > 1.e-10 ) then
-               alim_star(ig,l)=alim_star(ig,l)/alim_star_tot(ig)
-            endif
-         enddo
-      enddo
-      alim_star_tot(:)=1.
-
-
-
+      d_temp(:)=0. ! Pour activer un contraste de temperature a la base
+                   ! du panache
+!  Cet appel pourrait être fait avant thermcell_plume dans thermcell_main
+      CALL thermcell_alim(thermals_flag_alim,ngrid,klev,ztv,d_temp,zlev,alim_star,lalim)
 
 !------------------------------------------------------------------------------
@@ -811,4 +793,5 @@
 !--------------------------------------------------------------------------
 
+      USE print_control_mod, ONLY: prt_level
       IMPLICIT NONE
 
@@ -816,5 +799,4 @@
 #include "YOETHF.h"
 #include "FCTTRE.h"
-#include "iniprint.h"
 #include "thermcell.h"
 
Index: /LMDZ5/branches/testing/libf/phylmd/time_phylmdz_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/time_phylmdz_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phylmd/time_phylmdz_mod.F90	(revision 2408)
@@ -0,0 +1,80 @@
+!
+! $Id: $
+!
+MODULE time_phylmdz_mod
+
+    IMPLICIT NONE
+    REAL,SAVE    :: pdtphys     ! physics time step (s)
+!$OMP THREADPRIVATE(pdtphys)
+    INTEGER,SAVE :: day_step_phy    ! number of physical steps per day
+!$OMP THREADPRIVATE(day_step_phy)
+    INTEGER,SAVE :: ndays       ! number of days to run
+!$OMP THREADPRIVATE(ndays)
+    INTEGER,SAVE :: annee_ref   ! reference year from the origin
+!$OMP THREADPRIVATE(annee_ref)
+    INTEGER,SAVE :: day_ref     ! reference year of the origin
+!$OMP THREADPRIVATE(day_ref)
+    INTEGER,SAVE :: day_ini     ! initial day of the run starting from 1st january of annee_ref
+!$OMP THREADPRIVATE(day_ini)
+    INTEGER,SAVE :: day_end     ! final day of the run starting from 1st january of annee_ref
+!$OMP THREADPRIVATE(day_end)
+    REAL,SAVE    :: start_time  ! starting time from the begining of the initial day
+!$OMP THREADPRIVATE(start_time)
+    INTEGER,SAVE :: raz_date
+!$OMP THREADPRIVATE(raz_date)
+
+    INTEGER,SAVE :: itau_phy     ! number of physiq iteration from origin
+!$OMP THREADPRIVATE(itau_phy)
+    INTEGER,SAVE :: itaufin_phy      ! final iteration (in itau_phy steps)
+!$OMP THREADPRIVATE(itaufin_phy)
+    REAL,SAVE    :: current_time ! current elapsed time (s) from the begining of the run
+!$OMP THREADPRIVATE(current_time)
+    
+
+CONTAINS
+
+  SUBROUTINE init_time(annee_ref_, day_ref_, day_ini_, start_time_, &
+                       ndays_, pdtphys_)
+  USE ioipsl_getin_p_mod, ONLY : getin_p
+  USE phys_cal_mod, ONLY: phys_cal_init
+  IMPLICIT NONE
+  INCLUDE 'YOMCST.h'
+    INTEGER, INTENT(IN) :: annee_ref_  
+    INTEGER, INTENT(IN) :: day_ref_    
+    INTEGER, INTENT(IN) :: day_ini_    
+    REAL,    INTENT(IN) :: start_time_ 
+    INTEGER, INTENT(IN) :: ndays_      
+    REAL,    INTENT(IN) :: pdtphys_    
+    
+    annee_ref    = annee_ref_
+    day_ref      = day_ref_
+    day_ini      = day_ini_
+    start_time   = start_time_
+    ndays        = ndays_
+    pdtphys      = pdtphys_
+    
+    ! Initialize module variable not inherited from dynamics
+    day_step_phy = NINT(rday/pdtphys)
+    day_end  = day_ini + ndays
+  
+    raz_date = 0
+    CALL getin_p('raz_date', raz_date)
+
+    current_time=0
+    
+    CALL phys_cal_init(annee_ref,day_ref)
+    
+  END SUBROUTINE init_time
+
+  SUBROUTINE init_iteration(itau_phy_)
+  IMPLICIT NONE
+    INTEGER, INTENT(IN) :: itau_phy_
+    itau_phy=itau_phy_
+    IF (raz_date==1) itau_phy=0
+    
+    itaufin_phy=itau_phy+NINT(ndays/pdtphys)
+    
+  END SUBROUTINE init_iteration
+
+END MODULE time_phylmdz_mod      
+
Index: /LMDZ5/branches/testing/libf/phylmd/tracinca_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/tracinca_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/tracinca_mod.F90	(revision 2408)
@@ -5,5 +5,11 @@
 ! This module prepares and calls the INCA main subroutines. 
 !
-
+  IMPLICIT NONE  
+
+  CHARACTER(len=4),SAVE :: config_inca
+!$OMP THREADPRIVATE(config_inca)
+                     ! config_inca='none' => without INCA
+                     ! config_inca='chem' => INCA with chemistry
+                     ! config_inca='aero' => INCA with aerosols
 CONTAINS
 
@@ -11,5 +17,6 @@
     ! This subroutine initialize some control varaibles. 
 
-    USE infotrac
+    USE infotrac_phy, ONLY: nbtr
+    USE ioipsl_getin_p_mod, ONLY: getin_p
     IMPLICIT NONE
     
@@ -22,5 +29,5 @@
     lessivage  =.FALSE.
     aerosol(:) = .FALSE.
-        
+
   END SUBROUTINE tracinca_init
 
@@ -42,16 +49,12 @@
 
     USE dimphy
-    USE infotrac
+    USE infotrac_phy, ONLY: nbtr
     USE vampir
-    USE comgeomphy
-    USE control_mod
     USE indice_sol_mod
-
-    
+    USE geometry_mod, ONLY: cell_area
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+    USE aero_mod, ONLY : naero_grp
     IMPLICIT NONE
     
-    INCLUDE "dimensions.h"
-    INCLUDE "paramet.h"
-
 !==========================================================================
 !                   -- DESCRIPTION DES ARGUMENTS --
@@ -97,8 +100,8 @@
     LOGICAL,INTENT(IN)                       :: aerosol_couple
     REAL,DIMENSION(klon,klev),INTENT(IN)     :: flxmass_w
-    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: tau_aero
-    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: piz_aero
-    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: cg_aero
-    CHARACTER(len=4),DIMENSION(9),INTENT(IN) :: rfname 
+    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: tau_aero
+    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: piz_aero
+    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: cg_aero
+    CHARACTER(len=4),DIMENSION(naero_grp),INTENT(IN) :: rfname 
     REAL,DIMENSION(klon,klev,2),INTENT(IN)   :: ccm 
 
@@ -145,5 +148,5 @@
          pplay,pdel,prfl,pmflxr,psfl,    &
          pmflxs,zpmfu,itop_con,ibas_con,  &
-         pphi,airephy,nstep,rneb,t_seri, &      
+         pphi,cell_area,nstep,rneb,t_seri, &      
          rh,tau_aero,piz_aero,cg_aero,   &
          rfname,ccm,lafin, config_inca)
@@ -162,5 +165,5 @@
          pplay,      & !pmid
          pdel,       & !pdel
-         airephy,    &
+         cell_area,  &
          pctsrf(1,1),& !oro
          ftsol,      & !tsurf
@@ -183,6 +186,6 @@
          sh,         & !sh
          rh,         & !rh
-         iip1,       & !nx
-         jjp1,       & !ny
+         nbp_lon+1,  & !nx
+         nbp_lat,    & !ny
          source )
 #endif
Index: /LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90	(revision 2408)
@@ -67,5 +67,5 @@
     
     USE dimphy
-    USE infotrac
+    USE infotrac_phy
     
     ! Input argument
@@ -77,5 +77,5 @@
     ! Allocate restart variables trs
     ALLOCATE( trs(klon,nbtr), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('traclmdz_from_restart', 'pb in allocation 1',1)
+    IF (ierr /= 0) CALL abort_physic('traclmdz_from_restart', 'pb in allocation 1',1)
     
     ! Initialize trs with values read from restart file 
@@ -89,5 +89,5 @@
     ! Initialization of the tracers should be done here only for those not found in the restart file.
     USE dimphy
-    USE infotrac
+    USE infotrac_phy
     USE regr_pr_comb_coefoz_m, ONLY: alloc_coefoz
     USE press_coefoz_m, ONLY: press_coefoz
@@ -96,6 +96,6 @@
     USE mod_phys_lmdz_para
     USE indice_sol_mod
-
-    INCLUDE "iniprint.h"
+    USE print_control_mod, ONLY: lunout
+
 ! Input variables
     REAL,DIMENSION(klon,nbsrf),INTENT(IN)     :: pctsrf ! Pourcentage de sol f(nature du sol)
@@ -133,26 +133,26 @@
 ! --------------------------------------------
     ALLOCATE( scavtr(nbtr), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('traclmdz_init', 'pb in allocation 9',1)
+    IF (ierr /= 0) CALL abort_physic('traclmdz_init', 'pb in allocation 9',1)
     scavtr(:)=1.
     
     ALLOCATE( radio(nbtr), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('traclmdz_init', 'pb in allocation 11',1)
+    IF (ierr /= 0) CALL abort_physic('traclmdz_init', 'pb in allocation 11',1)
     radio(:) = .false.    ! Par defaut pas decroissance radioactive
     
     ALLOCATE( masktr(klon,nbtr), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('traclmdz_init', 'pb in allocation 2',1)
+    IF (ierr /= 0) CALL abort_physic('traclmdz_init', 'pb in allocation 2',1)
     
     ALLOCATE( fshtr(klon,nbtr), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('traclmdz_init', 'pb in allocation 3',1)
+    IF (ierr /= 0) CALL abort_physic('traclmdz_init', 'pb in allocation 3',1)
     
     ALLOCATE( hsoltr(nbtr), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('traclmdz_init', 'pb in allocation 4',1)
+    IF (ierr /= 0) CALL abort_physic('traclmdz_init', 'pb in allocation 4',1)
     
     ALLOCATE( tautr(nbtr), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('traclmdz_init', 'pb in allocation 5',1)
+    IF (ierr /= 0) CALL abort_physic('traclmdz_init', 'pb in allocation 5',1)
     tautr(:)  = 0.
     
     ALLOCATE( vdeptr(nbtr), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('traclmdz_init', 'pb in allocation 6',1)
+    IF (ierr /= 0) CALL abort_physic('traclmdz_init', 'pb in allocation 6',1)
     vdeptr(:) = 0.
 
@@ -343,5 +343,5 @@
     
     USE dimphy
-    USE infotrac
+    USE infotrac_phy
     USE regr_pr_comb_coefoz_m, ONLY: regr_pr_comb_coefoz
     USE o3_chem_m, ONLY: o3_chem
@@ -626,5 +626,5 @@
     ! variable trs is written to restart file (restartphy.nc)
     USE dimphy
-    USE infotrac
+    USE infotrac_phy
     
     REAL,DIMENSION(klon,nbtr), INTENT(OUT) :: trs_out
Index: /LMDZ5/branches/testing/libf/phylmd/tracreprobus_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/tracreprobus_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/tracreprobus_mod.F90	(revision 2408)
@@ -12,5 +12,5 @@
 
     USE dimphy
-    USE infotrac
+    USE infotrac_phy
 #ifdef REPROBUS 
     USE CHEM_REP, ONLY : pdt_rep, &  ! pas de temps reprobus
Index: /LMDZ5/branches/testing/libf/phylmd/transp.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/transp.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/transp.F90	(revision 2408)
@@ -13,6 +13,4 @@
   ! ======================================================================
 
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
   include "YOMCST.h"
 
Index: /LMDZ5/branches/testing/libf/phylmd/transp_lay.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/transp_lay.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/transp_lay.F90	(revision 2408)
@@ -13,6 +13,4 @@
   ! ======================================================================
 
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
   include "YOMCST.h"
 
Index: /LMDZ5/branches/testing/libf/phylmd/undefSTD.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/undefSTD.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/undefSTD.F90	(revision 2408)
@@ -37,7 +37,4 @@
   ! ====================================================================
 
-  ! ym#include "dimensions.h"
-  ! ym      integer jjmp1
-  ! ym      parameter (jjmp1=jjm+1-1/jjm)
   ! ym#include "dimphy.h"
   ! variables Input
Index: /LMDZ5/branches/testing/libf/phylmd/ustarhb.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/ustarhb.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/ustarhb.F90	(revision 2408)
@@ -18,6 +18,4 @@
   ! model. J. of Climate, vol. 6, 1825-1842.
   ! ======================================================================
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
   include "YOMCST.h"
 
Index: /LMDZ5/branches/testing/libf/phylmd/vdif_kcay.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/vdif_kcay.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/vdif_kcay.F90	(revision 2408)
@@ -6,8 +6,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! .......................................................................
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! .......................................................................
 
   ! dt : pas de temps
